<?php
include '../../control.php';
class myBlock extends block 
{
    /**
     * Block Index Page.
     *
     * @access public
     * @return void
     */
    public function index()
    {
        parent::index();
    }

    /**
     * Print invest, loan, receivable and payable block.
     *
     * @access public
     * @return void
     */
    public function printFundsBlock()
    {
        $this->app->loadLang('trade', 'cash');
        $this->app->loadLang('receivable', 'cash');
        $this->app->loadLang('payable', 'cash');
        $this->processParams();

        $investAmount   = 0;
        $redeemAmount   = 0;
        $unredeemAmount = 0;
        $loanAmount     = 0;
        $repayAmount    = 0;
        $unrepayAmount  = 0;

        $investProgress   = '0';
        $loanProgress     = '0';
        $receivedProgress = '0';
        $paidProgress     = '0';

        $trades = $this->dao->select('type, money, exchangeRate')->from(TABLE_TRADE)
            ->where('parent')->eq('0')
            ->andWhere('type', true)->eq('invest')
            ->orWhere('type')->eq('loan')
            ->orWhere('type')->eq('redeem')
            ->orWhere('type')->eq('repay')
            ->markRight(1)
            ->fetchAll();

        foreach($trades as $trade) ${$trade->type . 'Amount'} += $trade->money * $trade->exchangeRate;

        $unredeemAmount = $investAmount - $redeemAmount;
        if($unredeemAmount < 0) $unredeemAmount = 0;
        if($investAmount) $investProgress = round($redeemAmount / $investAmount * 100, 2);

        $unrepayAmount  = $loanAmount - $repayAmount;
        if($unrepayAmount < 0)  $unrepayAmount = 0;
        if($loanAmount) $loanProgress = round($repayAmount / $loanAmount * 100, 2);

        $receivableDetails = $this->loadModel('receivable')->getTotalMoney('receivable');
        $receivableAmount  = !empty($receivableDetails->deserved) ? $receivableDetails->deserved : 0;
        $unreceivedAmount  = !empty($receivableDetails->balance)  ? $receivableDetails->balance  : 0;
        if($receivableAmount) $receivedProgress = 100 - round($unreceivedAmount / $receivableAmount * 100, 2);

        $payableDetails = $this->receivable->getTotalMoney('payable');
        $payableAmound  = !empty($payableDetails->deserved) ? $payableDetails->deserved : 0;
        $unpaidAmound   = !empty($payableDetails->balance)  ? $payableDetails->balance  : 0;
        if($payableAmound) $paidProgress = 100 - round($unpaidAmound / $payableAmound * 100, 2);

        $this->view->investAmount     = $investAmount;
        $this->view->unredeemAmount   = $unredeemAmount;
        $this->view->investProgress   = $this->checkProgress($investProgress);

        $this->view->loanAmount       = $loanAmount;
        $this->view->unrepayAmount    = $unrepayAmount;
        $this->view->loanProgress     = $this->checkProgress($loanProgress);

        $this->view->receivableAmount = $receivableAmount;
        $this->view->unreceivedAmount = $unreceivedAmount;
        $this->view->receivedProgress = $this->checkProgress($receivedProgress);

        $this->view->payableAmound    = $payableAmound;
        $this->view->unpaidAmound     = $unpaidAmound;
        $this->view->paidProgress     = $this->checkProgress($paidProgress);

        $this->display('block', 'fundsblock');
    }

    public function checkProgress($progress)
    {
        if($progress > 100) $progress = 100;
        if($progress < 0)   $progress = 0;
        return $progress . '%';
    }
}
